#ifndef FOUNDATION_GLOBAL_INCLUDED
#define FOUNDATION_GLOBAL_INCLUDED
typedef	signed		char			int8;
typedef	signed		short			int16;
typedef	signed		int				int32;

#if	defined(__alpha)	||	defined(__ALPHA)
typedef	signed		long			int64;
#else
typedef	signed		long	long	int64;
#endif

typedef	unsigned	char			uint8;
typedef	unsigned	short			uint16;
typedef	unsigned	int				uint32;

#if	defined(__alpha)	||	defined(__ALPHA)
typedef	unsigned	long			uint64;
#else
typedef	unsigned	long	long	uint64;
#endif

#if	defined(__alpha)	||	defined(__ALPHA)
typedef	unsigned	long			Address;
typedef	unsigned	long			Counter;
#else
typedef	unsigned	long	long	Address;
typedef	unsigned	long	long	Counter;
#endif

typedef	unsigned	char			byte;

typedef	unsigned	int				uint;

#	define	true	1
#	define	false	0

#	define	cint8(xxx)		((int8)(xxx))
#	define	cint16(xxx)		((int16)(xxx))
#	define	cint32(xxx)		((int32)(xxx))
#	define	cint64(xxx)		((int64)(xxx))
#	define	cuint8(xxx)		((uint8)(xxx))
#	define	cuint16(xxx)	((uint16)(xxx))
#	define	cuint32(xxx)	((uint32)(xxx))
#	define	cuint64(xxx)	((uint64)(xxx))

#	define	Max(a,b)	(((a) < (b)) ? (b) : (a))
#	define	Min(a,b)	(((a) > (b)) ? (b) : (a))


#endif
