#include"Util/File.h"
#include"Instruction.h"
#include"WSOpCode.h"

#include"uniform_INST.def"

#define INST(OP, IN_COUNT, OUT_COUNT, IMM, IS_MEM, INPUTS, AUTO_INPUTS, OUTPUTS, AUTO_OUTPUTS, FIRE_0_SET, FIRE_0_CODE, FIRE_1_SET, FIRE_1_CODE, FIRE_2_SET, FIRE_2_CODE) \
     void OP##_Test()							\
     {									\
	  Instruction *sources[IN_COUNT];				\
	  Instruction *sinks[OUT_COUNT];				\
	  Instruction *op;						\
	  op = Instruction::Create(OP_ENUM(OP), 1);			\
	  uint64 c = 3;							\
	  uint i;							\
	  								\
	  for(i = 0; i < IN_COUNT; i++) {				\
	       char buf[100];						\
	       sprintf(buf, #OP " source %d", i);			\
	       sources[i] = Instruction::Create(OP_src, 0, buf); \
	       From((*sources[i])[0], (*op)[i]);			\
	  }								\
	  								\
	  for(i = 0; i < OUT_COUNT; i++) {				\
	       char buf[100];						\
	       sprintf(buf, #OP " sink %d", i);				\
	       sinks[i] = Instruction::Create(OP_sink,buf);	\
	       From((*op)[i], (*sinks[i])[0]);				\
	  }								\
	  								\
	  for(i = 0; i < IN_COUNT; i++) {				\
	       sources[i]->Fire(WaveScalarValue(1, 2, c++));		\
	  }								\
     }


#undef CUSTOM_INST
#define CUSTOM_INST(OP, IN_COUNT, OUT_COUNT, IMM, IS_MEM, INPUTS, AUTO_INPUTS, OUTPUTS, AUTO_OUTPUTS) 
#define LINK(a,b)
#include"Instructions.def"
#undef INST

int main (int argc, char *argv[]) 
{
     
#define INST(OP, IN_COUNT, OUT_COUNT, IMM, IS_MEM, INPUTS, AUTO_INPUTS, OUTPUTS, AUTO_OUTPUTS, FIRE_0_SET, FIRE_0_CODE, FIRE_1_SET, FIRE_1_CODE, FIRE_2_SET, FIRE_2_CODE) \
     File::Stdout.Print("============ " #OP " ============\n");\
     OP##_Test();
     
#include"Instructions.def"
#undef INST
#undef CUSTOM_INST

}
