#include"Util/File.h"

#define INPUT_FORMAT "%n%-20s", &i
#define OUTPUT_FORMAT "%n%-20s", &i
#define INPUT(a) inputs[a]
#define OUTPUT(a) outputs[a]
#define ZERO_IN  File::Stdout.Print(INPUT_FORMAT, "")
#define ZERO_OUT File::Stdout.Print(OUTPUT_FORMAT, "")
#define ONE_IN(a) File::Stdout.Print(INPUT_FORMAT, ", " #a)
#define ONE_OUT(a) File::Stdout.Print(OUTPUT_FORMAT, ", " #a)
#define TWO_IN(a, b) File::Stdout.Print(INPUT_FORMAT, ", " #a ", " #b)
#define TWO_OUT(a, b) File::Stdout.Print(OUTPUT_FORMAT, ", " #a ", " #b)
#define THREE_IN(a, b,c) File::Stdout.Print(INPUT_FORMAT, ", " #a ", " #b ", " #c)
#define THREE_OUT(a, b,c) File::Stdout.Print(OUTPUT_FORMAT, ", " #a ", " #b ", " #c)
#define FOUR_IN(a, b,c,d)  File::Stdout.Print(INPUT_FORMAT, ", " #a ", " #b ", " #c ", " #d)
#define FOUR_OUT(a, b,c,d) File::Stdout.Print(OUTPUT_FORMAT, ", " #a ", " #b ", " #c ", " #d)
#define LINK(real, virt) File::Stdout.Print(#real " -> " #virt "\n");

#include "uniform_INST.def"
#define INST(OP, IN_COUNT, OUT_COUNT, IMM, IS_MEM, INPUTS, AUTO_INPUTS, OUTPUTS, AUTO_OUTPUTS, FIRE_0_IN_SET, FIRE_0_OUT_SET, FIRE_0_CODE, FIRE_1_IN_SET, FIRE_1_OUT_SET, FIRE_1_CODE, FIRE_2_IN_SET, FIRE_2_OUT_SET, FIRE_2_CODE) \
      File::Stdout.Print("%n%-20s", &i, #OP);				\
 OUTPUTS;								\
 INPUTS;									\
 if(IMM) {								\
      File::Stdout.Print(", #");				\
 }									\
 if(IS_MEM) {								\
      File::Stdout.Print(", <p, c, n>");			\
 }									\
 File::Stdout.Print("\n");

int main (int argc, char*argv[]) 
{
     int i;
#include"Instructions.def"

     
     return 0;
}
