#ifndef __STATICBARRIER_HEADER
#define __STATICBARRIER_HEADER

#define STATIC_BARRIER_CREATE(NAME, COUNT, NOTIFY_ARC)       \
.scope_explicit_import NAME                                | \
  .import NOTIFY_ARC                                       | \
  tc      count, take, newcount_f                          | \
  addl    newcount, count, incr_val                        | \
  cmpeq_I isCountReached, newcount, COUNT                  | \
  rho     NOTIFY_ARC, newcount_f, newcount, isCountReached | \
.endscope

#define STATIC_BARRIER_INCR_BY_N(NAME, TRIGGER, N) \
  cnst NAME::incr_val, TRIGGER, N | \
  ttd NAME::take, TRIGGER

#define STATIC_BARRIER_INCR(NAME, TRIGGER) STATIC_BARRIER_INCR_BY_N(NAME, TRIGGER, 1)
#endif
