#ifndef __ASM_TID_HEADER
#define __ASM_TID_HEADER

#include <threads/defs.h>

#define GET_NEXT_TID(targ_arc, trig_arc) \
.scope_explicit_import |\
.import targ_arc as target, trig_arc as trigger |\
.import TSECTION::next_tid_tc as tid_tc, TSECTION::next_tid_is as tid_is | \
	cnst {^tid_tc:1, zero}, trigger, 0 |\
target_label: ir target |\
       cnst ^tid_is:1, trigger, ^target_label |\
	addl_I next_tid, target, 1 |\
	dtt ^tid_tc:2, zero, next_tid |\
.endscope

#endif
