#ifndef __THREADS_HEADER
#define __THREADS_HEADER

#include <ws/types.h>

typedef wsint64 (*thread_fn)(tid_t  tid, wsint64  a0, wsint64 a2, wsint64 a3);
tid_t thread_create_pc(thread_fn fnptr, wsint64 a1, wsint64 a2, wsint64 a3);
void thread_detach(tid_t tid);
wsint64 thread_join(tid_t tid);
tid_t thread_get_tid(void);

#endif // __THREADS_HEADER
