#ifndef  DECODED_INSTRUCTION_DEFINED
#define  DECODED_INSTRUCTION_DEFINED

typedef struct _DECODED_INSTRUCTION {
     // RB is never an output and RC is never an input.  RA is schizo and is a
     // dst for loads, but mostly a src.
     bool_t RAIsOutput;
     bool_t RAIsInput;
     bool_t RBIsInput;
     bool_t RCIsOutput;

     bool_t controlIsInput;

     bool_t hasImmediate;

     bool_t RAIsZero;
     bool_t RBIsZero;
     bool_t RCIsZero;
     
     bool_t needInputA;
     bool_t needInputB;

     bool_t outputA;
     bool_t outputC;
     
     bool_t isLoad;
     bool_t isStore;
     bool_t isConditionalMove;

     enum md_opcode op;

} DecodedInstruction;

#endif
