#include "wsArch.h"
#include "functionDefs.h"

// These are the the output types that get output by a function.  The table for
// translations is in inst.c

////////////////////////////////////////////////////////////////////////////////
//////////  Changing this array means you should change the version number in
//////////  execFormat.h.  It is not strictly a change in the format, but it
//////////  will probably break surfer.
////////////////////////////////////////////////////////////////////////////////
int functionOutputRegs[] = {0, // OUTPUT_RETURN
			    
			    26, //OUTPUT_RA,
			    
			    29, // OUTPUT_GP,
			    30, // OUTPUT_SP,
			    32 + 0, // OUTPUT_FP0, 
			    32 + 1, // OUTPUT_FP1, 
			    FUNCTION_WAVE_REGISTER, //OUTPUT_WAVE, 
			    -1};

//////////////////////////////////////////////////////////////////////////
////////////// IF you add or remove something here, you must alter functionDef.h as well
/////////////////////////////////////////////////////////////////////////
int functionInputRegs [] = {     
     RETURN_ADDRESS_REGISTER,
     0,  /*OUTPUT_RET*/  
     15, /*OUTPUT_FP*/   
     16, /*OUTPUT_A0*/   
     17, /*OUTPUT_A1*/   
     18, /*OUTPUT_A2*/   
     19, /*OUTPUT_A3*/   
     20, /*OUTPUT_A4*/   
     21, /*OUTPUT_A5*/   
     26, /*OUTPUT_RA*/   
     27, /*OUTPUT_PV*/   
     29, /*OUTPUT_GP*/   
     30, /*OUTPUT_SP*/   
     32, /*OUTPUT_FP0*/  
     33, /*OUTPUT_FP1*/  
     48, /*OUTPUT_FPA0*/ 
     49, /*OUTPUT_FPA1*/ 
     50, /*OUTPUT_FPA2*/ 
     51, /*OUTPUT_FPA3*/ 
     52, /*OUTPUT_FPA4*/ 
     53, /*OUTPUT_FPA5*/ 
     FUNCTION_WAVE_REGISTER, /*OUTPUT_WAVE*/ 
     -1
};
