#ifndef OP_DEFS_INCLUDED
#define OP_DEFS_INCLUDED


#ifndef IN_SURFER
#include"md_opcode.h"
#endif

#include"WSOpCode.h"



typedef enum {/* INPUT_RET, */
	      
/* 	      INPUT_FP, */
	      
/* 	      INPUT_A0, */
/* 	      INPUT_A1, */
/* 	      INPUT_A2, */
/* 	      INPUT_A3, */
/* 	      INPUT_A4, */
/* 	      INPUT_A5, */
	      
/* 	      INPUT_RA, */
/* 	      INPUT_PV, */
	     
/* 	      INPUT_GP, */
/* 	      INPUT_SP, */

/* 	      INPUT_FP0, */
/* 	      INPUT_FP1, */

/* 	      INPUT_FPA0, */
/* 	      INPUT_FPA1, */
/* 	      INPUT_FPA2, */
/* 	      INPUT_FPA3, */
/* 	      INPUT_FPA4, */
/* 	      INPUT_FPA5, */
/* 	      INPUT_WAVE, */
	      
	      INPUT_A,  
	      INPUT_B, 
	      INPUT_C,
	      //INPUT_PREDICATE,  // rho-function only
	      //	      INPUT_CONTROL,     // for no-input instructions.  Always alone
	      //	      INPUT_TAKEN, /* These two are for phi functions */
	      // INPUT_NOT_TAKEN,
	      //INPUT_LOOP_ENTRY,	/* These are for loop phi functions */
	      //INPUT_LOOP_CARRIED,
	      /* INPUT_MEM, */
/* 	      INPUT_MEM_ORDER, */
/* 	      INPUT_MEM_ORDER_COORDINATION, */
//	      INPUT_OTHER, // Used in ssa.c, but this code is stale. 
	      //	      INPUT_SWITCH,
	      //INPUT_JMP_DST, // Only used for old-style function calls
	      //INPUT_IDENTITY,
	      //INPUT_CMOVE,
	      INPUT_SERIALIZE,
	      // INPUT_EPOCH,
	      //	      INPUT_EPOCH_COORDINATION,
	      //	      INPUT_SPECIAL_ARCH_TRACE,
	      INPUT_LOAD_VALUE,
	      INPUT_LOAD_REQUEST, // These four are for the store buffer 
	      INPUT_STORE_REQUEST,
	      INPUT_MEM_NOOP_REQUEST,
	      INPUT_WAVE_ADVANCE_REQUEST,
	      INPUT_MAX,
	      INPUT_INVALID} InputArgType;

extern char *INPUT_ARG_TYPE_NAME[];


typedef enum {/* OUTPUT_RET, */
	      
/* 	      OUTPUT_FP, */
	      
/* 	      OUTPUT_A0, */
/* 	      OUTPUT_A1, */
/* 	      OUTPUT_A2, */
/* 	      OUTPUT_A3, */
/* 	      OUTPUT_A4, */
/* 	      OUTPUT_A5, */

/* 	      OUTPUT_RA, */
/* 	      OUTPUT_PV, */

/* 	      OUTPUT_GP, */
/* 	      OUTPUT_SP, */
	      
/* 	      OUTPUT_FP0, */
/* 	      OUTPUT_FP1, */

/* 	      OUTPUT_FPA0, */
/* 	      OUTPUT_FPA1, */
/* 	      OUTPUT_FPA2, */
/* 	      OUTPUT_FPA3, */
/* 	      OUTPUT_FPA4, */
/* 	      OUTPUT_FPA5, */
/* 	      OUTPUT_WAVE, */

	      OUTPUT_A,   // TAKEN
	      OUTPUT_B,   // NOT TAKEN
	      OUTPUT_C,
	      //	      OUTPUT_OUT,
	      OUTPUT_CONTROL,
 /* 	      OUTPUT_CONTROL_NOT_TAKEN, */
/* 	      OUTPUT_CONTROL_TAKEN, */
/* 	      OUTPUT_NOT_TAKEN,	/\* These are for rho functions *\/ */
/* 	      OUTPUT_TAKEN, */
/* 	      OUTPUT_MEM, */
/* 	      OUTPUT_MEM_ORDER, */
/* 	      OUTPUT_MEM_LOAD_ORDER, */
/* 	      OUTPUT_MEM_STORE_ORDER, */
/* 	      OUTPUT_MEM_ORDER_COORDINATION, */
//	      OUTPUT_JMP_DST,
	      //	      OUTPUT_OTHER,
	      OUTPUT_SERIALIZE,
/* 	      OUTPUT_EPOCH, */
/* 	      OUTPUT_EPOCH_COORDINATION, */
/* 	      OUTPUT_SPECIAL_ARCH_TRACE, */
	      OUTPUT_MEM_REQUEST_ADDR,
	      OUTPUT_MEM_REQUEST_DATA,
	      OUTPUT_LOAD_RESPONSE,
	      OUTPUT_MAX,
	      OUTPUT_INVALID} OutputArgType;                                      
            
extern char *OUTPUT_ARG_TYPE_NAME[];

typedef WSOpCode InstType;
#define OP_TYPE_MAX WSOpCodeMax

#if (0)
typedef enum {OP_TYPE_ALPHA_OP,
	      OP_TYPE_PHI_FUNC,
	      OP_TYPE_RHO_FUNC,
	      //	      OP_TYPE_TAG_SINK,
	      OP_TYPE_SPECIAL_SINK,
	      OP_TYPE_SPECIAL_SOURCE,
	      OP_TYPE_FUNCTION_CALL,
	      //	      OP_TYPE_MEM_ORDER_LOAD,
	      //	      OP_TYPE_MEM_ORDER_STORE,
	      OP_TYPE_COPY,
	      OP_TYPE_EPOCH_ADVANCE,
	      //	      OP_TYPE_EPOCH_COORDINATOR,
	      OP_TYPE_MEM_NOOP,
	      OP_TYPE_INDIRECT_SEND,
	      OP_TYPE_SEND,
	      OP_TYPE_MAX} InstType;
#endif

extern char *OP_TYPE_NAME[];

/* extern int ARG_TYPE_TO_REG[]; */
/* extern int REG_TO_ARG_TYPE[]; */

#ifndef IN_SURFER
extern char *WSOpCode_NAME[];
extern WSOpCode SSToWSMap[OP_MAX + 1];
void InitSSToWSMap();
#endif

#endif
