#include <assert.h>
#include<stdlib.h>

static void *heapTop;
static void *memBase;

void wsMallocInit(void *memBlock)
{
     assert(memBlock != NULL);
     memBase = memBlock;
     heapTop = memBlock;
}

void *wsMalloc(unsigned int size)
{
     void *ret = heapTop;
     (unsigned int)heapTop += size;
     return ret;
}

void *wsCalloc(unsigned int size, unsigned int count)
{
     void *ret = wsMalloc(size*count);
     char *t = (char *)ret;
     uint i;
     for(i = 0; i < size*count; i++) {
       t[i] = '\0';
     }
     return ret;
}

void wsFree(void *p)
{}
