#!/usr/bin/perl -w

package Drip::Type::UINTType;
use strict;

BEGIN {
    our @ISA = qw( Drip::Type::INTType );
    our %FIELDS = (
    );
    __PACKAGE__->DECLARE_ACCESSORS;
}

sub instanceDeclaration
{
    my $self = shift;
    my $name = shift;
    return "u" . $self->SUPER::instanceDeclaration($name);
}

sub getCFnNameStem {
    my $self = shift;
    return "Unsigned" . $self->SUPER::getCFnNameStem;
}

# sub validate {
#     my $self = shift;
#     my $value = shift;
#     return 0 unless $self->SUPER::validate($value);
#     return $value >= 0;
# }

sub toString
{
    my $self = shift;
    return "UINT(" . $self->precision() . ")";
}

1;
