#!/usr/bin/perl -w
package Pebble::Constants;
use strict;
use Exporter;
use Bit::Vector::Overload;
BEGIN { Bit::Vector::Overload->Configuration("in=decimal,out=hexadecimal,ops=arithmetic"); }
our @ISA = qw(Exporter);
our @EXPORT_OK = qw( WS_WORDSIZE WAVEORDER_UNKNOWN RIPPLE_DEFAULT );

use constant WS_WORDSIZE       => 64;
use constant WAVEORDER_UNKNOWN => Bit::Vector->new_Dec(32, -1);
use constant RIPPLE_DEFAULT    => Bit::Vector->new_Dec(32, 1);
