




















	



















.section .code
.version 1
#include "fixopcodes.h"

.declare_labels lcs
.scope_explicit_import lcs
.import lcs
lcs:
func_start RA           .attrs(regNum=80)
func_start OUTPUT_RET   .attrs(regNum=0)
func_start OUTPUT_FP    .attrs(regNum=15)
func_start thread_id  .attrs(regNum=16)
func_start Size_sarg  .attrs(regNum=17)
func_start String1_sarg         .attrs(regNum=18)
func_start String2_sarg      .attrs(regNum=19)
func_start notused_sarg      .attrs(regNum=20)
func_start size_x_sarg  .attrs(regNum=21)
func_start OUTPUT_RA    .attrs(regNum=26)
func_start OUTPUT_PV    .attrs(regNum=27)
func_start OUTPUT_GP    .attrs(regNum=29)
func_start OUTPUT_SP    .attrs(regNum=30)
func_start OUTPUT_FP0   .attrs(regNum=32)
func_start OUTPUT_FP1   .attrs(regNum=33)
func_start OUTPUT_FPA0  .attrs(regNum=48)
func_start OUTPUT_FPA1  .attrs(regNum=49)
func_start OUTPUT_FPA2  .attrs(regNum=50)
func_start OUTPUT_FPA3  .attrs(regNum=51)
func_start OUTPUT_FPA4  .attrs(regNum=52)
func_start OUTPUT_FPA5  .attrs(regNum=53)
func_start RENDEVOUS_WAVE   .attrs(regNum=78)
	wa	Size_arg, Size_sarg
	wa	String1_arg, String1_sarg
	wa	String2_arg, String2_sarg

	// init the top left 0 (may have to be wave++)
	// init by loading in the arrays
	li	kickerW, Size_arg, 0
	ttd	origThread, Size_arg
	slli	{origT, kickerT}, origThread, 12
	cmplt	{ kickerWLoop_eq, kickerWLoop_start }, kickerW, Size_arg

	wtd	kickerWLoop_sync, kickerWLoop_start
	wtd		kickerWLoop_sync_end_wave, kickerWLoop_sync_end
	dtw		kickerWLoop_sync_fini, kickerWLoop_sync_end, kickerWLoop_sync_end_wave
	rho	Size_arg_loop, Size_arg_end, { Size_arg, Size_arg_loop }, kickerWLoop_eq .attrs(waveAdvanceAmount=1)
	rho	origT_loop, origT_end, { origT, origT_loop }, kickerWLoop_eq .attrs(waveAdvanceAmount=1)
	rho	kickerWLoop_sync_loop, kickerWLoop_sync_end, { kickerWLoop_sync, kickerWLoop_sync_next }, kickerWLoop_eq .attrs(waveAdvanceAmount=1)
	rho	kickerT_loop, kickerT_end, { kickerT, kickerT_next }, kickerWLoop_eq .attrs(waveAdvanceAmount=1)
	rho	kickerW_loop, kickerW_end, { kickerW, kickerW_next }, kickerWLoop_eq .attrs(waveAdvanceAmount=1)
	rho	String1_arg_loop, String1_arg_end, { String1_arg, String1_arg_next }, kickerWLoop_eq .attrs(waveAdvanceAmount=1)
	rho	String2_arg_loop, String2_arg_end, { String2_arg, String2_arg_next }, kickerWLoop_eq .attrs(waveAdvanceAmount=1)
		ldq_u_U	vString_fromUp, String1_arg_loop, 0
		ldq_u_U	vString_fromLeft, String2_arg_loop, 0
		li		kicker_Zero, kickerW_loop, 0
		/* send into the right */
		dttw	String_fromLeft, kickerT_loop,	kicker_Zero, vString_fromLeft
		dttw	Value_fromLeft,	kickerT_loop,	kicker_Zero, kicker_Zero
		dttw	Row, kickerT_loop,	kicker_Zero, kickerW_next
		cmpeq	firstIteration, kickerW_loop, kicker_Zero
		rho		{ }, kickerT_loopNZ, kickerT_loop, firstIteration
		rho		{ }, kicker_ZeroNZ, kicker_Zero, firstIteration
		dttw	Value_fromUpperLeft, kickerT_loopNZ, kicker_ZeroNZ, kicker_ZeroNZ

		/* send into the top */
		dttw	String_fromUp,	origT_loop,	kickerW_loop, vString_fromUp
		dttw	Value_fromUp,	origT_loop,	kickerW_loop, kicker_Zero
		dttw	StringSize,		origT_loop,	kickerW_loop, Size_arg_loop
		dttw	Column,			origT_loop,	kickerW_loop, kickerW_next
		dttw	Value_fromUpperLeft, origT_loop, kickerW_loop, kicker_Zero

		addi	String1_arg_next, String1_arg_loop, 1
		addi	String2_arg_next, String2_arg_loop, 1
		addi	kickerW_next, kickerW_loop, 1
		addi	kickerT_next, kickerT_loop, 1
		cmplt	kickerWLoop_eq, kickerW_next, Size_arg_loop
	nop  kickerWLoop_sync_next, kickerWLoop_sync_loop

	/* Ok, Every thread is going to get:
		Row, Column, StringSize, String_fromUp, String_fromLeft, and
		Value_fromUpperLeft, Value_fromUp, and Value_fromLeft
	*/

	/* do the actual LCS */
	addi	A_plus, Value_fromUp, 1
	cmpeq	match, String_fromUp, String_fromLeft
	cmple	CisBigger, Value_fromLeft, Value_fromUpperLeft
	phi		biggerIn, Value_fromUpperLeft, Value_fromLeft, CisBigger
	phi		result, A_plus, biggerIn, match

	/* compute how to fling stuff around */
	cmplt	goRight, Column, StringSize
	cmplt	goDown, Row, StringSize
	opand	goDownRight, goRight, goDown
	addq	goAnywhere, goRight, goDown

	/* stuff to send right */
	rho		String_fromLeft, { }, String_fromLeft, goRight	.attrs(waveAdvanceAmount=1)
	rho		Value_fromLeft, { }, result, goRight	.attrs(waveAdvanceAmount=1)
	rho		Row, { }, Row, goRight	.attrs(waveAdvanceAmount=1)
	/* stuff to send down */
	rho		String_fromUp, { }, String_fromUp, goDown	.attrs(threadAdvanceAmount=1)
	rho		Value_fromUp, { }, result, goDown	.attrs(threadAdvanceAmount=1)
	rho		StringSize, { }, StringSize, goDown	.attrs(threadAdvanceAmount=1)
	rho		Column, { }, Column, goDown	.attrs(threadAdvanceAmount=1)

	/* stuff to pop out to the lower right */
	rho		Value_fromUpperLeft, { }, result, goDownRight .attrs(waveAdvanceAmount=1,threadAdvanceAmount=1)
	rho		{ }, IamDone_butfix, result, goAnywhere
	rho		{ }, StringSize_end, StringSize, goAnywhere

	/* termination

	on termination, we get "IamDone_butfix" sent.  Now the only problem it exists on
	wave + StringSize and thread + StringSize
	trick is to convert it ;-)
	 */


	li	newWave, IamDone_butfix, 1
	ttd	oldThread, IamDone_butfix
	subi	StringSize_end2, StringSize_end, 1
	subq	newT, oldThread, StringSize_end2
	srli	newThread, newT, 12
	dttw	trueResult, newThread, newWave, IamDone_butfix

	// copied from MMUL
    li doneOne, trueResult, 1
    dtw owdone, doneOne, trueResult
    li RAOne, RA, 1
    wtd RAWave, RA
    dtw owRAWave, RAOne, RAWave
    dtw rwdone, owRAWave, owdone
    wait doneRA, RA, rwdone

	
	
.scope_explicit 
.import RA as peOUTPUT_RETURN 
.import RENDEVOUS_WAVE as peRENDEVOUS_WAVE 
.import doneRA as peRA 
.declare_arcs rwOUTPUT_RA, rwOUTPUT_GP, rwOUTPUT_SP, rwOUTPUT_FP0, rwOUTPUT_FP1
.declare_arcs peOUTPUT_RA, peOUTPUT_GP, peOUTPUT_SP, peOUTPUT_FP0, peOUTPUT_FP1
.declare_arcs raInRendevousWave, currWaveInRendevousWave 
wtd peCurrWave, peRENDEVOUS_WAVE 
dtw rwCurrWave, peRENDEVOUS_WAVE, peCurrWave 
dtw rwOUTPUT_RA, lcs::RENDEVOUS_WAVE, lcs::OUTPUT_RA
dtw rwOUTPUT_GP, lcs::RENDEVOUS_WAVE, lcs::OUTPUT_GP 
dtw rwOUTPUT_SP, lcs::RENDEVOUS_WAVE, lcs::OUTPUT_SP 
dtw rwOUTPUT_FP0, lcs::RENDEVOUS_WAVE, lcs::OUTPUT_FP0 
dtw rwOUTPUT_FP1, lcs::RENDEVOUS_WAVE, lcs::OUTPUT_FP1 
dtw peOUTPUT_RA, rwCurrWave, rwOUTPUT_RA 
dtw peOUTPUT_GP, rwCurrWave, rwOUTPUT_GP 
dtw peOUTPUT_SP, rwCurrWave, rwOUTPUT_SP 
dtw peOUTPUT_FP0, rwCurrWave, rwOUTPUT_FP0 
dtw peOUTPUT_FP1, rwCurrWave, rwOUTPUT_FP1 
dtw raInRendevouseWave, peRENDEVOUS_WAVE, peRA 
dtw currWaveInRendevousWave, peRENDEVOUS_WAVE, peCurrWave
isret  peOUTPUT_RETURN, peRA, 0 .attrs(regNum=0);
isret  peOUTPUT_RA,     peRA, 1 .attrs(regNum=26);
isret  peOUTPUT_GP,     peRA, 2 .attrs(regNum=29);
isret  peOUTPUT_SP,     peRA, 3 .attrs(regNum=30);
isret  peOUTPUT_FP0,    peRA, 4 .attrs(regNum=32);
isret  peOUTPUT_FP1,    peRA, 5 .attrs(regNum=33);
isret  currWaveInRendevousWave, raInRendevouseWave, 6 .attrs(regNum=78);
.endscope 
.endscope

