#!/usr/bin/perl -w

use Cwd;

my $cpandir = getcwd() . "/cpan";
my $installprefix = getcwd();
my $localcpancache = "$cpandir/sources";

$CPAN::Config->{keep_source_where} = $localcpancache;
$CPAN::Config->{build_dir}         = "$cpandir/build";
$CPAN::Config->{cpan_home}         = $cpandir;
push @{$CPAN::Config->{urllist}}, "ftp://ftp.perl.org/pub/CPAN";
unshift @{$CPAN::Config->{urllist}}, $localcpancache;
$CPAN::Config->{makepl_arg} .= qq[ PREFIX=$installprefix LIB=$installprefix/lib];

1;

