#ifndef PRINTABLE_INCLUDED
#define PRINTABLE_INCLUDED

#include<string>
using std::string;

class Printable {
 private:
     /**
      * This method can lead to memory leaks because it new's but does not
      * free.  It's primary purpose is to be called from gdb while debugging,
      * hence it is private.
      */
     virtual const char *ToString() {string s; return ToString(s);}

public:
     virtual const char *ToString(string &s) const { s += "UNDEFINED PRINT METHOD"; return s.c_str();}
     
     virtual void Print(FILE *f) {string s; fprintf(f, ToString(s)); }
     Printable(){};
     virtual ~Printable(){};
};


#endif
