#ifndef	_wsemulate_h
#	define	_wsemulate_h

#warning "Compiling with WaveScalar Emulation.  Be sure to use -pthread and -lpthread"

typedef	unsigned	long	long	wsuint64;
typedef	long	long	wsint64;
typedef	int	mutex_id;

#include	<pthread.h>
#	define	tid_t	wsuint64

/* mutex.h */
mutex_id	mutex_create();
wsuint64	mutex_acquire(mutex_id);
void		mutex_release(mutex_id, wsuint64	data);

/* thread.h */
void initialize_tid_acquire(void);
void deinitialize_tid_acquire(void);
tid_t tid_acquire(void);

typedef wsint64 (*thread_fn)(wsint64 tid, wsint64  a0, wsint64 a2, wsint64 a3);
tid_t thread_create_pc(thread_fn fnptr, wsint64 a1, wsint64 a2, wsint64 a3);
void thread_detach(tid_t tid);
wsint64 thread_join(tid_t tid);
tid_t thread_get_tid(void);

/* wsMalloc.h */
#define	wsMallocIinit(m)
#define	wsMalloc(m)			malloc(m)
#define	wsFree(m)			free(m)
#define	wsCalloc(m,n)		calloc(m,n)

#endif

