#ifndef __MCSLOCK_HEADER
#define __MCSLOCK_HEADER

#include <memthreads/mtypes.h>

typedef struct _mcs_qnode mcs_qnode_t;
typedef mcs_qnode_t * mcs_lock_t;

struct _mcs_qnode {
  volatile mcs_qnode_t *next;
  volatile wsint64 locked;
};

void mcs_lock_initialize(volatile mcs_lock_t *lock);
void mcs_lock_acquire(volatile mcs_lock_t *lock);
void mcs_lock_release(volatile mcs_lock_t *lock);

#endif
