#ifndef __BARRIER_HEADER
#define __BARRIER_HEADER

#include <ws/types.h>

barrier_id barrier_create(wsint64 max_count);

wsint64 barrier_thread(barrier_id id, wsint64 max_count);

void barrier_reset(barrier_id id, wsint64 new_max_count);

void barrier_wait(barrier_id id);

void barrier_destroy(barrier_id id);

#endif // __BARRIER_HEADER
