#ifndef TYPES_INCLUDED
#define TYPES_INCLUDED

#ifndef IN_SURFER
#include <glib.h>
#else
// system compatibility
#	include	"Core/Compatibility.h"

// foundation classes (arrays, fifo's, stacks, etc)
#	include	"Core/Global.h"

typedef uint64 guint64;
typedef uint32 guint32;
#endif

#include "host.h"
typedef unsigned char SmallCount;

typedef unsigned long long int PC;
typedef guint64 StatCount;

#ifndef IN_SURFER
typedef guint32 Counter;
#endif
typedef guint64 Asid;
typedef guint64 ThreadID;
typedef guint64 Epoch;
typedef Epoch Wave;
typedef guint32 RippleSize;
typedef int MemSequence;

typedef long int InstructionID;

typedef guint32 InstructionInstance;

typedef unsigned long TransmissionID;

typedef unsigned int Count;
typedef unsigned int QueueNum;
typedef unsigned int MemOrder;

/* address type definition */
typedef qword_t md_addr_t;

#endif
