
#include <threads/defs.h>
#include <asm/procs.h>

.section .code

PROC_START(atomic_swap)
    cwa  rw_wa,      RENDEVOUS_WAVE               <?, 1, 2>.0
    wa   addr_wa,    OUTPUT_A0
    wa   val_wa,     OUTPUT_A1
    wa   ra_wa,      RA
    swap oldval_wa,  addr_wa, val_wa              <1, 2, 1>.1
PROC_END(atomic_swap, oldval_wa, rw_wa, ra_wa)

PROC_START(compare_and_swap)
    cwa  rw_wa,      RENDEVOUS_WAVE               <?, 1, 2>.0
    wa   addr_wa,    OUTPUT_A0
    wa   test_wa,    OUTPUT_A1
    wa   newval_wa,  OUTPUT_A2
    wa   ra_wa,      RA
    cas  success_wa, addr_wa, test_wa, newval_wa  <1, 2, 1>.1
PROC_END(compare_and_swap, success_wa, rw_wa, ra_wa)
