/**
 * Implementation of mthread_ methods
 *
 * $Id: memthreads.c,v 1.6 2004/02/27 02:03:18 schwerin Exp $
 */

#include <ws/tid_acquire.h>
#include <memthreads/mthreads.h>
#include <assert.h>
//#include <memthreads/qlock.h>

mthread_global_t _mthread_global;
union _mthread_context_u _mtcdata[MAXTHREADS];

/* mtid_t mthread_create_pc(mthread_fn fnptr, void *param) */
/* { */
/*   qlock_acquire(MT_GLOBAL_QLOCK); */
/*   if(!TQ_EMPTY(MT_GLOBAL_FREE_TIDQ)) { */
/*     next_tid = TQ_DEQUEUE(MT_GLOBAL_FREE_TIDQ); */
/*   } else { */
/*     next_tid = MT_GLOBAL_NEXT_MTID++; */
/*   } */
/*   qlock_release(MT_GLOBAL_QLOCK); */
/*   memset(&MT_CONTEXT(next_tid), sizeof(MT_CONTEXT(next_tid)), 0); */
/*  _mthread_launch_pc(fnptr, tid, param, (void *)_mthread_do_run); */
/* } */

/* void mthread_detach(mtid_t tid) { MT_CONTEXT(tid).is_detached = 1; } */

#define MTHREAD_JOIN_IS_IMPLEMENTED 0
void * mthread_join(mtid_t tid) { assert(MTHREAD_JOIN_IS_IMPLEMENTED); }

mtid_t mthread_get_tid(void) { return thread_get_tid(); }

/* void _mthread_do_run(mthread_fn fnptr, mtid_t tid, void *param) */
/* { */
/*   void *rval; */
/*   rval = fnptr(tid, param); */
/*   // do the joining crap here. */
/* } */

wsint64 mthread_doer(mtid_t tid, wsint64 fnptr, wsint64 param, wsint64 a3)
{
  memset(&MT_CONTEXT(tid), sizeof(MT_CONTEXT(tid)), 0);
  return ((mthread_fn)fnptr)(tid, (void *)param);
}

mtid_t mthread_create_pc(mthread_fn fnptr, void *param)
{
  return thread_create_pc(mthread_doer, (wsint64)fnptr, (wsint64)param, 0);
}
void mthread_detach(mtid_t tid) { thread_detach(tid); }

