#!/usr/bin/perl -w

package Drip::IOString;
use Carp;
use strict;

sub new {
    my $str = "";
    return bless( \$str, __PACKAGE__ );
}

sub print {
    my $self = shift;
    $$self .= join("", @_);
}

sub read {
    scalar(@_) == 3 or die("correct syntax: read FH, SCALAR, LENGTH");
    my $amtread = (length(${$_[0]}) < $_[2]) ? length(${$_[0]}) : $_[2];
    $_[1] = substr(${$_[0]}, 0, $amtread);
    ${$_[0]} = substr(${$_[0]}, $amtread);
    return $amtread;
}

sub printf {
    my $self = shift;
    $$self .= sprintf(@_);
}

sub debug {
    my $sos = new Drip::IOString;
    $sos->print ("Willy ", "Wonka");
    my $fh = \*STDOUT;
    $fh->print ($$sos);
}

1;
