#!/usr/bin/perl -w

package Pebble::MacroInstance;
use strict;
use Carp;
use Pebble::CodeInstance;

BEGIN {
    our @ISA = qw ( Pebble::CodeInstance );
    our %FIELDS = ( 'macrodef'   => 'Pebble::MacroDef' );
    __PACKAGE__->DECLARE_ACCESSORS;
}

sub initialize
{
    croak("Wrong number of parameters") unless 4 == scalar @_;
    my $self = shift;
    my $macrodef = shift;
    $self = $self->SUPER::initialize( @_ );
    $self->macrodef( $macrodef );
    return $self;
}

1;
