#!/usr/bin/perl -w

use strict;

package Pebble::Visitor;
use Carp;

sub visitAssemblyUnit
{
    my $visitor = $_[0];
    my $asmunit = $_[1];

    $_->visit($visitor) foreach $asmunit->sections;
}

sub visitSection
{
    my $visitor = $_[0];
    my $section = $_[1];
#    print STDERR "Visiting section ", $section->name, " in ", $visitor, "\n";
    $_->visit($visitor) foreach $section->prgBlocks;
}


sub visitPrgBlock
{
    my $visitor = $_[0];
    my $prgblock = $_[1];
    $_->visit($visitor) foreach $prgblock->codeItems;
}


sub visitInstrInstance
{
    carp("Visiting $_[1]");
}

1;
