
;;;
;;; This file contains symbols which are external to it.
;;;
        
.section .code

.proc   barrier_reset ( bBarrierReset_tid_in, new_max_count )
.export ^barrier_reset as barrier_reset
        ;; Get the wave next wave number in the barrier thread
        cnst    {  ^.code::bwn_tc:1, ^.code::bwn_rho:3 }, bBarrierReset_tid_in, 0
        ;; Construct a reset message
        wtd     req_wave, bBarrierReset_tid_in
        ttd     req_tid, bBarrierReset_tid_in
        EQI     isNewMaxCountZero, new_max_count, 0
        cnst    minusone, new_max_count, -1
        phi     req_max_count, minusone, new_max_count, isNewMaxCountZero
        ;; Send the reset message
        dttw    barrier_thread::rbreq_tid_pad_IN, bBarrierReset_tid_in, ^.code::bwn_rho:1, req_tid
        dttw    barrier_thread::rbreq_wave_pad_IN, bBarrierReset_tid_in, ^.code::bwn_rho:1, req_wave
        dttw    barrier_thread::rbreq_msg_pad_IN, bBarrierReset_tid_in, ^.code::bwn_rho:1, req_max_count
.endproc
