
	;; tm output t.w.v input1 t.w.k input2 k.u.v
	;; wr output t.w+1.v input t.w.v
	;; wtd output t.w.w input t.w.v
	;; dtw output t.w.v input1 t.u.v input2 t.u.w
	;; ttd output t.w.t input t.w.v
	;; dtt output t.w.v input1 k.w.v input2 k.w.t
	;; rho output1 (if input2==true) output2 (if input2==false) input1 t.w.v input2 t.w.c
	;; phi output (if input3 == true then pass input1 else pass input2)
	;; is output1 t.w.v input1 t.w.v input2 t.w.a
	;; ceq output1 t.w.c where c = v1 == v2 of t.w.v1 and t.w.v2
	;; sub output1 = input1 - input2
	;; is send input1 to address of second input t.w.a
	
;; dttw output k.u.v input1 t.w.v input2 t.w.k input3 t.w.u
@macro	dttw	outToken, inToken, newThread, newWave
	.scope_explicit_declare
       .declare_arcs t1, t2
	dtw	t1, inToken, newWave
	dtw	t2, newThread, newWave
	dtt	outToken, t1, t2
	.endscope
@endmacro

@macro	sendi	toArc, value, trigger
	li	toArc, value, trigger
@endmacro

@macro	send	toArc, value
	addi	toArc, value, 0
@endmacro

;; toArc is signaled.  AcuiqreSignalName is the lock acquire and addrlock is the
;; address lockAcquire is input
@macro	checkout	toArc, AcquireSignalName, addrLock, valueAcquire
	sendi		addrLock, temp1, lockAcquire
	send		AcquireSignalName, lockAcquire
	send		toArc, temp1
@endmacro

@macro	checkin		setSignal, lockRelease
	send		setSignal, lockRelease
@endmacro
	
.section .insmemory
	
;;; in-grid memory elements
curr_tcount:		tm	the_curr_tcount, acquire_curr_tcount, set_curr_tcount
			is	the_curr_tcount, addrfor_curr_tcount
curr_max_tcount:	tm	the_max_tcount, acquire_max_tcount, set_max_tcount
			is	the_max_tcount, addrfor_max_tcount
waiting_threads:	tm	the_waiting_thread, acquire_the_waiting_thread, set_the_waiting_thread
			is	the_waiting_thread, addrfor_the_waiting_thread
.section .code

;; ;;; send t.w.k and t.w.ra where k is the barrier to acquire
;; .proc		barrier(fromThread, fromThread_ra)
	.scope
	send	acquire_the_waiting_thread, fromThread
	send	addrfor_the_waiting_thread, fromThread_ra
;;; checkout current count
	send	acquire_curr_tcount, fromThread
	sendi	addrfor_curr_tcount, old_curr_tcount_dest, fromThread
	add	new_curr_tcount, old_curr_tcount_dest, 1
	send	acquire_max_tcount, triggerfromlock
	sendi	addrfor_max_tcount, temp0, triggerfromlock
	send	{ set_max_tcount_rt, temp_max_tcount }, temp0
	dtt	set_max_tcount, set_max_tcount_rt, fromThread
	ceq	reached_barrier, new_curr_tcount, temp_max_tcount
	rho	release_barrier, wait_for_more, new_curr_tcount, reached_barrier
	rho	release_barrier_ft, wait_for_more_ft, fromThread, reached_barrier
	;; wait for more threads, update current count
	dtt	{ set_curr_count }, wait_for_more, wait_for_more_ft
	;; this is the release code until release_barrer = 0 trigger waiting_threads
	;; its helpful to do this in the k thread
	dtt	release_barrier_ink, release_barrier, release_barrier_ft
	wr	release_barrier_ink_new, release_barrier_ink
	send	set_the_waiting_thread, release_barrier_ink_new
	sub	release_barrier_ink_new_dec, release_barrier_ink_new, 1
	ceq	release_trigger, release_barrier_ink_new_dec, 0	
	rho	release_trigger_finish, release_barrier_ink, release_barrier_ink_new_dec, release_trigger
	;; finished, release the lock
	send	{ set_curr_count  }, release_trigger_finish
	.endscope

;; .proc		barrier_reset(fromThread)
;; 	.scope
;; ;;; acquire curr count
;; 	send	acquire_curr_tcount, fromThread
;; 	sendi	addrfor_curr_tcount, $+1^0, fromThread
;; 	send	temp_curr_tcount, { }
;; ;;; jump into the k thread
;; 	dtt	temp_curr_tcount_ink, temp_curr_tcount, fromThread
;; 	wr	temp_curr_tcount_ink_new, { temp_curr_tcount_ink, loop_repeat }
;; 	send	set_the_waiting_thread, temp_curr_tcount_ink_new
;; 	sub	new_temp_curr_tcount_ink_new, temp_curr_tcount_ink_new, 1
;; 	ceq	finish_trigger, new_temp_curr_tcount_ink_new, 0
;; 	rho	finished, loop_repeat, new_temp_curr_tcount_ink_new, finish_trigger
;; 	send	set_curr_tcount, finished
;; 	.endscope
